/*  keyfunc.c
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/keyfunc.c,v 0.6 1995/03/31 10:05:47 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"

char *onfunc(us of)
{
    char *keyfunc;
    switch(of)
    {
	case 0x0007:    return("bell");
	case 0x0008:    return("backspace");
	case 0x0009:    return("tab");
	case 0x000d:    return("return");
	case 0x007f:    return("delete-character");
	case 0x03e9:    return("go");
	case 0x03ea:    return("help");
	case 0x03eb:    return("insert-mode");
	case 0x03ec:    return("end-error");
	case 0x03ed:    return("endkey");
	case 0x03ee:    return("error");
	case 0x03ef:    return("get");
	case 0x03f0:    return("put");
	case 0x03f1:    return("recall");
	case 0x03f2:    return("clear");
	case 0x03f3:    return("new-line");
	case 0x03f4:    return("delete-line");
	case 0x03f5:    return("break-line");
	case 0x03f6:    return("append-line");
	case 0x03f7:    return("block");
	case 0x03f8:    return("find");
	case 0x03f9:    return("page-up");
	case 0x03fa:    return("page-down");
	case 0x03fb:    return("back-tab");
	case 0x03fc:    return("cursor-up");
	case 0x03fd:    return("cursor-down");
	case 0x03fe:    return("cursor-left");
	case 0x03ff:    return("cursor-right");
	case 0x0400:    return("home");
	case 0x0401:    return("stop");
	case 0x0404:    return("stop-display");
	case 0x0405:    return("resume-display");
	case 0x0406:    return("right-end");
	case 0x0407:    return("left-end");
	case 0x0408:    return("choices");
	case 0x0409:    return("settings");
	case 0x040a:    return("reports");
	case 0x040b:    return("goto");
	case 0x040c:    return("scroll-left");
	case 0x040d:    return("scroll-right");
	case 0x040e:    return("insert-field");
	case 0x040f:    return("insert-field-data");
	case 0x0410:    return("insert-field-label");
	case 0x0411:    return("delete-field");
	case 0x0412:    return("insert-column");
	case 0x0413:    return("delete-column");
	case 0x0414:    return("pick");
	case 0x0415:    return("pick-both");
	case 0x0416:    return("cancel-pick");
	case 0x0417:    return("move");
	case 0x0418:    return("top-column");
	case 0x0419:    return("bottom-column");
	case 0x041a:    return("main-menu");
	case 0x041b:    return("pick-area");
	case 0x041c:    return("options");
	default:        keyfunc = malloc(20);
			if (keyfunc == NULL)
			    faterror("No memory for keyfunc");
			sprintf(keyfunc, "? KEYFUNTION %04x", of);
			return(keyfunc);
    }
}
