/*  stream.c 
    Copyright (C) 1993  Grant Philip Maizels

    $Header: /usr/src/dp/RCS/stream.c,v 0.6 1995/03/31 10:05:49 gpm Exp $

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "dp.h"

void lists()  /* print out a list of the streams */
{

/* FIXME: the gs(STRLIST) + 16 * s + 15  is likely to be byte order dependent
 * but I have not had a chance to test on little endian machines.
 */

    us s;
    for (s = 0; s < gs(STRCNT); s++)
    {
       dump('S', gs(STRLIST) + 16 * s, 16);
       printf("define ");
       if(gs(gs(STRLIST) + 16 * s + 14) == 1)
	   printf("shared ");
       if(gs(gs(STRLIST) + 16 * s + 14) == 2)
	   printf("new shared ");
       if(gs(gs(STRLIST) + 16 * s + 14) == 3)
	   printf("new global shared ");
       printf("stream %s.\n", p + gs(STRLIST) + 16 * s);
    }
}
